@echo off

set systemTypeTA=32
set systemTypeGC=x86
if /i %PROCESSOR_IDENTIFIER:~0,3%==x86 (
	set systemTypeTA=32
	set systemTypeGC=x86
) else (
	set systemTypeTA=64
	set systemTypeGC=amd64
)

set version=xp
ver|find "5." >nul
if %errorlevel% == 0 set version=xp
ver|find "6." >nul
if %errorlevel% == 0 set version=win7_10
ver|find "10." >nul
if %errorlevel% == 0 set version=win7_10

echo SYSTEM TYPE: %version% %systemTypeTA%
echo -------------------------------------
cd %~dp0\%version%
.\%systemTypeGC%\devcon.exe remove "USB\VID_067B&PID_23A3"
.\%systemTypeTA%\devcon.exe remove "USB\VID_067B&PID_2303"
echo Driver Removed
echo -------------------------------------

echo Delete Driver "plser"
wmic sysdriver where name="plser" delete

echo Delete Driver "plserx86"
wmic sysdriver where name="plserx86" delete

echo Delete Driver "ser2pl"
wmic sysdriver where name="ser2pl" delete

set searchPath=C:\WINDOWS\system32\
FOR /R "%searchPath%" %%a  in (ser2pl* plser*) DO (
    IF EXIST "%%~fa" (
	echo Del File: "%%~fa"
        del /f /q "%%~fa" 
    )
)

echo Driver Deleted
echo -------------------------------------

reg delete "HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Windows\DeviceInstall\Restrictions\DenyDeviceClasses" /v 217 /f

echo Restore Driver Installation
echo -------------------------------------

.\%systemTypeTA%\devcon.exe rescan
.\%systemTypeGC%\devcon.exe updateni plser.inf "USB\VID_067B&PID_23A3"
.\%systemTypeTA%\devcon.exe updateni ser2pl.inf "USB\VID_067B&PID_2303"
.\%systemTypeTA%\devcon.exe rescan

echo Driver Installed
echo -------------------------------------

reg add "HKLM\SOFTWARE\Policies\Microsoft\Windows\DeviceInstall\Restrictions" /v DenyDeviceClasses /t REG_DWORD /d 1 /f
reg add "HKLM\SOFTWARE\Policies\Microsoft\Windows\DeviceInstall\Restrictions" /v DenyDeviceClassesRetroactive /t REG_DWORD /d 0 /f
reg add "HKEY_LOCAL_MACHINE\SOFTWARE\Policies\Microsoft\Windows\DeviceInstall\Restrictions\DenyDeviceClasses" /v 217 /d {4d36e978-e325-11ce-bfc1-08002be10318} /f

echo Disable pl2303 driver installation
echo -------------------------------------
pause